exact.probs <- function(probs) {
  # p <- probs / (1 - probs) * prod(1 - probs)
  p <- probs / (1 - probs)

  p / sum(p)
}

estimate.probs <- function(probs, N = 10^6) {
  kills <- lapply(probs, function(p) sample(1:0, size = N, prob = c(p, 1-p), replace = TRUE))
  kills <- do.call(cbind, kills) # We can use just `sapply` here

  kills <- kills[rowSums(kills) == 1,, drop = TRUE]
  colMeans(kills)
}

estimate.probs(c(0.1, 0.2, 0.3))
exact.probs(c(0.1, 0.2, 0.3))

sim.killers <- function(probs, N = 10^6) {
  kills <- lapply(probs, function(p) sample(1:0, size = N, prob = c(p, 1-p), replace = TRUE))
  kills <- do.call(cbind, kills) # We can use just `sapply` here

  res <- rep(NA_integer_, N)
  one.kill <- rowSums(kills) == 1
  res[one.kill] <- max.col(kills[one.kill,, drop = TRUE])
  res[!one.kill] <- 0

  res
}

tt <- table(sim.killers(c(0.1, 0.2, 0.3)))

tt
tt[2:4] / sum(tt[2:4])

