library(lattice)

goals.rate <- function(N) {
  x <- runif(N, min = -1, max = 1)
  y <- runif(N, min = -1, max = 1)

  mean(x^2 + y^2 <= 1)
}

exact.prob <- pi / 4

Ns <- 2 ^ (1:20)

estimates <- sapply(Ns, goals.rate)

errors <- estimates - exact.prob

xyplot(errors ~ Ns)

xyplot(abs(errors) ~ Ns, scales = list(log = 2))
xyplot(abs(errors) * sqrt(Ns) ~ Ns, scales = list(log = 2))
xyplot(abs(errors) * Ns ~ Ns, scales = list(log = 2))


n <- 100
rmses <- sapply(Ns, function(N) sqrt(mean((replicate(n, goals.rate(N)) - exact.prob)^2)))

xyplot(abs(rmses) ~ Ns, scales = list(log = 2))
xyplot(abs(rmses) * sqrt(Ns) ~ Ns, scales = list(log = 2))
xyplot(abs(rmses) * Ns ~ Ns, scales = list(log = 2))
